package ch.rp.core.shared.spring;

import java.io.Serializable;

import org.aopalliance.intercept.MethodInvocation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ejb.access.SimpleRemoteStatelessSessionProxyFactoryBean;

public class LeafCompatibleRemoteEJBProxyFactoryBean extends SimpleRemoteStatelessSessionProxyFactoryBean implements Serializable {

    private static final long serialVersionUID = -2823087691916621502L;

    private static final Logger LOGGER = LoggerFactory.getLogger(LeafCompatibleRemoteEJBProxyFactoryBean.class);

    @Override
    protected Object doInvoke(MethodInvocation invocation) throws Throwable {

        if (LOGGER.isDebugEnabled()) {
            StringBuffer sb = new StringBuffer();
            sb.append("Invocation of EJB ");
            sb.append(getJndiName() + "\n");
            sb.append("on server ");
            sb.append(getJndiEnvironment() + "\n");
            sb.append("method");
            sb.append(invocation.getMethod().getName() + "\n");
            LOGGER.debug(sb.toString());
        }

		return super.doInvoke(invocation);

    }
}
