package ch.rp.services.sharedcontext.ejb.interceptor;

import org.jboss.ejb.client.EJBClientInterceptor;
import org.jboss.ejb.client.EJBClientInvocationContext;

import ch.rp.services.sharedcontext.SharedContextHolder;
import ch.rp.services.sharedcontext.SharedContextService;

public class SharedContextEJBClientInterceptor implements EJBClientInterceptor {

    public void handleInvocation(EJBClientInvocationContext context) throws Exception {
        //Inject the sharedContext Holder into the EJBClient Context
        SharedContextHolder holder = null;
        if (SharedContextService.getInstance().isClient()) {
            holder = SharedContextService.getInstance().getClientSharedContext();
        } else {
            holder = SharedContextService.getInstance().getThreadSharedContext();
        }
        context.getContextData().put(SharedContextHolder.SHARED_CONTEXT_HOLDER_KEY, holder);

        context.sendRequest();
    }

    public Object handleInvocationResult(EJBClientInvocationContext context) throws Exception {
        return context.getResult();
    }

}
