package ch.rp.jboss.test.project.gui;

import java.util.Scanner;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import ch.rp.jboss.test.project1.Service1;
import ch.rp.services.sharedcontext.SharedContextService;

public class Main {

	private static final String SPRING_APPLICATION_CONTEXT = "spring/project-gui-context.xml";
	private static final String QUIT_ACTION = "q";
	private static final Logger LOGGER = LoggerFactory.getLogger(Main.class);

	public static void main(String[] args) {
		
		SharedContextService.getInstance().getClientSharedContext().setUserName("testJboss");
		String[] contextPaths = new String[] { SPRING_APPLICATION_CONTEXT };
		ClassPathXmlApplicationContext ctx = new ClassPathXmlApplicationContext(contextPaths);

		Service1 service1 = ctx.getBean(Service1.class);

		String action = "";
		while(!QUIT_ACTION.equals(action)){
			// create a scanner so we can read the command-line input
		    Scanner scanner = new Scanner(System.in);
	
			LOGGER.info("Use [s] to start the test or [q] to quit: ");
	
		    // get their input as a String
			action = scanner.next();
			
			try{
				switch (action) {
				case "s":
					service1.executeAction7();
					LOGGER.info("Service called.");
					break;
				default:
	
				}
			}
			catch(Exception e){
				e.printStackTrace();
				LOGGER.info(e.getMessage());
			}

		} 
		LOGGER.info("Exit App");

	}
}
