package ch.rp.jboss.test.project1;

import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;

import ch.rp.jboss.test.project1.entity.Project1Entity;
import ch.rp.services.sharedcontext.SharedContextService;

public class Project1DAOImpl implements Project1DAO {

	@Autowired
	private SessionFactory sessionFactory;

	public void updateRow(Project1Entity entity) {
		sessionFactory.getCurrentSession().update(entity);
		sessionFactory.getCurrentSession().flush();
    }

	public Project1Entity insertRow() {
    	Project1Entity entity = new Project1Entity();
    	String name = SharedContextService.getInstance().getThreadSharedContext().getActionId();
		if (name.length() > 40) {
			name = name.substring(0, 40);
		}
    	entity.setName(name);
    	entity.setValue("testJboss");
		Project1Entity entitySaved = (Project1Entity) sessionFactory.getCurrentSession().merge(entity);

		sessionFactory.getCurrentSession().flush();
		return entitySaved;
   }
	
	public Project1Entity insertRow(String message) {
    	Project1Entity entity = new Project1Entity();
    	String name = SharedContextService.getInstance().getThreadSharedContext().getActionId();
		if (name.length() > 40) {
			name = name.substring(0, 40);
		}
    	entity.setName(name);
    	entity.setValue(message);
		Project1Entity entitySaved = (Project1Entity) sessionFactory.getCurrentSession().merge(entity);

		sessionFactory.getCurrentSession().flush();
		return entitySaved;
   }

}
