package ch.rp.jboss.test.project1;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.interceptor.Interceptors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ejb.interceptor.SpringBeanAutowiringInterceptor;

import ch.rp.core.shared.ejb.interceptor.RollbackExceptionInterceptor;
import ch.rp.jboss.test.project1.entity.Project1Entity;
import ch.rp.jboss.test.project2.Service2;

@Interceptors({SpringBeanAutowiringInterceptor.class,RollbackExceptionInterceptor.class})
@Remote(Service1.class)
@Stateless(name="Service1")
public class Service1Impl implements Service1 {

	private static final Logger LOGGER = LoggerFactory.getLogger(Service1Impl.class);

	@Autowired
	Project1DAO project1DAO;

	@Autowired
	Service2 service2;

	public void executeAction7(){
		LOGGER.info("Insert Row in PROJECT_1 table");
		Project1Entity entity = project1DAO.insertRow();
		LOGGER.info("--> row " + entity.getId() + " inserted");
		LOGGER.info("Call Action 7 on server 2");
		service2.insertRowAndRecallServer1();
		LOGGER.info("Action 7 on server 2 called");
	}
	

	public void executeSecondActionInitiatedByServer2() {
		Project1Entity entity = project1DAO.insertRow("Call from server 2");
		LOGGER.info("--> row " + entity.getId() + " inserted");
		LOGGER.info("Call Action 3 (printLog) on server 2");
		service2.printLog();
		LOGGER.info("Action 3 on server 2 called.");
	}


}
