package ch.rp.jboss.test.project2;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.interceptor.Interceptors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ejb.interceptor.SpringBeanAutowiringInterceptor;

import ch.rp.core.shared.ejb.interceptor.RollbackExceptionInterceptor;
import ch.rp.jboss.test.project1.Service1;
import ch.rp.jboss.test.project2.entity.Project2Entity;

@Interceptors({SpringBeanAutowiringInterceptor.class,RollbackExceptionInterceptor.class})
@Remote(Service2.class)
@Stateless(name="Service2")
public class Service2Impl implements Service2{
	private static final Logger LOGGER = LoggerFactory.getLogger(Service2Impl.class);

	@Autowired
	Project2DAO project2DAO;

    @Autowired
    Service1 service1;

	public void insertRowAndRecallServer1(){
		LOGGER.info("Insert Row in PROJECT_2 table");
		Project2Entity entity = project2DAO.insertRow();
		LOGGER.info("--> row " + entity.getId() + " inserted");
		service1.executeSecondActionInitiatedByServer2();
	}
	
	@Override
	public void printLog() {
		LOGGER.info("Print log");
	}
}
